package str.classtree;

import java.io.FileInputStream;
import java.io.InputStream;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;

import str.classtree.atermify.ClassATermifier;
import str.bcel.EnclosingMethod;
import org.apache.bcel.classfile.*;
import org.apache.bcel.generic.*;
import aterm.*;

/**
 * @author Martin Bravenboer <martin@cs.uu.nl>
 * Original author: Dave Clarke (Fri Aug 29 2003)
 */
public class Class2ATerm {
  static {
    EnclosingMethod.register();
  }

  public static String disasm_from_jar(String jar, String name) throws IOException {
    Config.disasm_code = false;
    ByteArrayOutputStream out = new ByteArrayOutputStream(2000);
    writeTerm(new ClassParser(jar, name).parse(), out);
    return out.toString();
  }

  public static String disasm(String input, String disasm) throws IOException {
    Config.disasm_code = false;
    if(disasm.equals("on")) {
      Config.disasm_code = true;
    }

    InputStream in = new FileInputStream(input);
    ByteArrayOutputStream out = new ByteArrayOutputStream(2000);
    writeTerm(readClass(in), out);
    in.close();
    return out.toString();
  }

  private static JavaClass readClass(InputStream stream) throws IOException  {
    return new ClassParser(stream, null).parse();
  }

  private static void writeTerm(JavaClass clazz, OutputStream stream) throws IOException {
    ClassATermifier atermifier = new ClassATermifier();
    ATerm classATerm = atermifier.convert(clazz);
    classATerm.writeToTextFile(stream);
  }
}
