package str.classtree.atermify;

import org.apache.bcel.Constants;
import org.apache.bcel.classfile.*;
import org.apache.bcel.generic.*;
import aterm.*;
import static str.classtree.atermify.ATermifyUtil.*;
import str.aterm.ATermifier;
import static str.aterm.ATermUtil.*;

public abstract class AbstractAttributeATermifier implements ATermifier<Attribute>
{
  public ATerm map(Attribute[] attrs)
  {
    ATermList result = _factory.makeList();
    for(int i = attrs.length - 1; i >= 0; i--)
    {
      ATerm next = convert(attrs[i]);
      if(next != null)
      {
	result = result.insert(next);
      }
    }

    return result;
  }

  public ATerm buildUnknownAttribute(Attribute attr)
  {
    ConstantUtf8 c;
    c = (ConstantUtf8) attr.getConstantPool().getConstant(attr.getNameIndex(),  Constants.CONSTANT_Utf8);
    return appl("UnknownAttribute", astring(c.getBytes()));
  }

  public ATerm buildDeprecatedAttribute(org.apache.bcel.classfile.Deprecated attr)
  {
    return appl("Deprecated");
  }

  public ATerm buildSyntheticAttribute(Synthetic attr)
  {
    return appl("Synthetic");
  }

  public String getNameOf(Attribute attr)
  {
    ConstantUtf8 c;
    c = (ConstantUtf8) attr.getConstantPool().getConstant(attr.getNameIndex(),  Constants.CONSTANT_Utf8);
    return c.getBytes();
  }

}
